#!/usr/bin/env python3
# -*- coding: utf-8 -*-

### Toutes les "constantes" de config importés pour ce qui concerne les courbes

# fichiers

chemin_oms = "data_OMS/"

f_poids_perc_garcon = chemin_oms+"wfa_boys_p_exp.txt"
f_poids_perc_fille = chemin_oms+"wfa_girls_p_exp.txt"
f_poids_z_garcon = chemin_oms+"wfa_boys_z_exp.txt"
f_poids_z_fille = chemin_oms+"wfa_girls_z_exp.txt"
f_poids_z_mixte = chemin_oms+"wfa_mix_z_exp.txt"
f_poids_perc_mixte = chemin_oms+"wfa_mix_p_exp.txt"

# Pour les courbes percentiles
liste_data_choisie_p = [(5,1),(7,5),(8,10),(10,25),(11,50),(12,75), (14,90),
              (15,95),(17,99)]
liste_data_choisie_p.sort(reverse=True)

# pour le sigma : (colonne,sigma)
liste_data_choisie_z = [(2,-3),(3,-2),(4,-1),(5,0),(6,1),(7,2),(8,3)]
liste_data_choisie_z.sort(reverse=True)


CONFIG = {}

liste_unites_valides = ["jours", "semaines", "mois", "années"]

# nombre de jours dans autre chose
jours_dans_mois = 30.4375
jours_dans_annee = 365.25
jours_dans_semaine = 7

## Maxi et mini de "sécurité"
# jours maxi
jours_maxi_courbe = 5.5*jours_dans_annee
# poids max (protection)
poids_maxi = 80
# taille max du nom
longueur_max_nom_bebe = 100

#largeurs et hauteurs min et max
largeur_graphique_max = 40
largeur_graphique_min = 3

hauteur_graphique_max = 40
hauteur_graphique_min = 2



## Configuration "par défaut" du graphique, tel qu'exporté ?
DEFAUT = {}

### Taille du graphique par défaut (pouces, en 80 points par pouce)
DEFAUT["largeur"] = 10
DEFAUT["hauteur"] = 7

# Nombre de lignes par défaut dans le formulaire
DEFAUT["nb_data"] = 6

# couleurs par défaut
DEFAUT["couleurs"] = {}
DEFAUT["couleurs"]["courbe1"] = "#0000FF" # bleu
DEFAUT["couleurs"]["courbe2"] = "#00FF00" # vert
DEFAUT["couleurs"]["courbe3"] = "#FF0000" # rouge
DEFAUT["couleurs"]["fond"]= "#FFFFFF" # blanc
DEFAUT["couleurs"]["cadretxt"] = "#000000" # noir
DEFAUT["couleurs"]["grille"] = "#7f7f7f" # gris
#couleur_defaut_1 = "#0000FF" # bleu
#couleur_defaut_2 = "#00FF00" # vert
#couleur_defaut_3 = "#FF0000" # rouge
CONFIG["couleurs"] = {
        "courbe1" : (0,0,1),
        "courbe2" : (0,1,0),
        "courbe3" : (1,0,0),
        "fond": (1,1,1),
        "cadretxt": (0,0,0),
        "grille": (0.5,0.5,0.5)
        }
#couleur_defaut_1_tuple = (0,0,1)
#couleur_defaut_2_tuple = (0,1,0)
#couleur_defaut_3_tuple = (1,0,0)

# couleurs par défaut fond
#couleur_defaut_fond = "#FFFFFF"
#couleur_defaut_fond_tuple = (1,1,1)
#couleur_defaut_cadretxt = "#000000"
#couleur_defaut_cadretxt_tuple = (0,0,0)
#couleur_defaut_grille = "#7f7f7f"
#couleur_defaut_grille_tuple = (0.5,0.5,0.5)

#couleur_defaut_erreur = (0,0,0) # noir


# initialiser la config
def config_init():
    c = DEFAUT.copy()
    c.update({
            "age_0": "0j",
            "legende": "oui",
            "positionlegende": "hg",
#            "couleur1": couleur_defaut_1,
#            "couleur2": couleur_defaut_2,
#            "couleur3": couleur_defaut_3,
#            "couleur_fond": couleur_defaut_fond,
#            "couleur_grille": couleur_defaut_grille,
#            "couleur_cadretxt": couleur_defaut_cadretxt
            })
            
    return c
    
    
